;*_____________________________________________________________________________
;*
;*           Author: Terry Carmen 
;* Released to the Public Domain 6/28/1996 
;*_____________________________________________________________________________
;*
;*
;*     Program Name:   bin2hex.asm 
;*        $Revision$
;*            $Date$
;*
;*
;*
;* Revision History:
;*             $Log$
;*
;*_____________________________________________________________________________


public BIN2HEX

extrn   __parinfo:far
extrn   __parc:far
extrn   __parclen:far
extrn   __retc:far
extrn   __ret:far

assume cs:_prog, ds:datasg, es:nothing

dgroup  group   datasg

datasg  segment public  para 'DATA'

        outstring    db 255 dup (' ')

        hexchars     db '0123456789ABCDEF'




datasg ends



_prog segment 'CODE'

BIN2HEX  Proc  far
                push    bp
                mov     bp,sp
                push    ds
                push    es
                push    si
                push    di

                mov     ax, 0
                push    ax
                call    __parinfo           ; how many params?
                add     sp,2
                cmp     al,1                ; should be 1
                jne     @@bad                  ; if not, we're out of here..

                mov     ax, 1               ; check the type
                push    ax
                call    __parinfo
                add     sp,2
                and     ax,1                ; is it a string?
                cmp     ax, 1
                jne     @@bad               ; if not, we're out of here..

                mov     ax, 1
                push    ax
                call    __parclen           ; how big is the string?
                add     sp,2
                cmp     ax,0
                je      @@bad               ; don't bother with null strings

                cmp     ax, 85            
                jg      @@bad               ; can't do more than an 85
                                            ; byte input string with a 

                jmp short @@ok              ; goofy jmp because of the 80xxx's
                                            ; conditional jump limit
@@bad:          jmp short @@bad_exit            
        
@@ok:           mov     cx,ax               ; save the length
                push    cx

                mov     ax, 1
                push    ax
                call    __parc              ; where is the string?
                add     sp,2                ; address in DX:AX

                pop     cx                  ; get the length back

                mov     ds, dx              ; DS:SI point to source
                mov     si, ax

                mov     ax, seg outstring   ; ES:DI points to our output string buffer
                mov     es, ax              
                mov     di, offset outstring

                cld                         ; set direction flag for loop
@@nextchar:                                        

                mov     al, byte ptr ds:[si] ; get first byte of input string in al

                and     al, 11110000b        ; get left nybble
                shr     al, 4                ; move it to the right

                add     al, '0'              ; convert to ASCII
                cmp     al, '9'              ; is it a pesky hex char?
                jg      @@fixhex1            ; yep.
                jmp     short @@hexdone1     ; no, all done

 @@fixhex1:        add     al, 7             ; fix it
 @@hexdone1:    mov     byte ptr es:[di], al ; save left char of hex number


                inc     di                   ; increment destination string pointer
                mov     al, byte ptr ds:[si] ; get same byte again
                and     al, 00001111b        ; get right nybble

                add     al, '0'              ; same as above
                cmp     al, '9'
                jg      @@fixhex2
                jmp     short @@hexdone2

 @@fixhex2:        add     al, 7
 @@hexdone2:    mov     byte ptr es:[di], al
                inc     di

                mov     byte ptr es:[di], ' '
                inc     di                     ; point to next char in output string
                inc     si                     ; point to next byte in input string

                loop     @@nextchar            ; decrement cx and loop if > 0

                dec     di                     ; hack off trailing space
                mov byte ptr es:[di], 0        ; and terminate the string
                
                jmp short @@returnstring

@@bad_exit:     call     __ret                 ; return NIL
                jmp short @@pops                



@@returnstring: mov    bx, offset outstring     ; point to our string
                mov    ax, seg outstring        ; so Clipper can find it
                push   ax                       ; push seg:ofs on stack
                push   bx

                mov    ax, seg dgroup       ; point ds to Clipper's dataseg
                mov    ds, ax               ; so it doesn't get all confused

                call    __retc              ; send the data back to Clipper

                add    sp,4                 ; fix the stack

@@pops:         pop    di
                pop    si
                pop    es
                pop    ds
                pop    bp
                Ret
BIN2HEX Endp


_prog Ends                            ; End of code Segment
End
