*+
*+
*+    Source Module => F:\HEXVIEW\HEXVIEW.PRG
*+
*+    Copyright (C) 1997, Phil Barnett. All Rights Reserved Worldwide.
*+
*+    Contents: Procedure HexView()
*+              Static Procedure FillArray()
*+              Static Procedure Hex_Disp()
*+              Static Function Dec2Hex()
*+              Static Procedure Cnt()
*+              Static Function MySearch()
*+              Static Procedure PutScreen()
*+              Static Procedure GetScreen()
*+              Static Procedure Usage()
*+              Static Function NewFile()
*+              Static Procedure header()
*+
*+    Reformatted by Click! on Apr-16-1997 at 11:15 pm
*+
*+
/*
HEXVIEW.PRG by Phil Barnett                        Origin Date 06/23/96
Released to Public Domain by author, Phil Barnett              06/23/96
Heavily modified for Screen size, search and more by Jo French 06/24/96
Continued speed refinements by Phil Barnett                    06/26/96
Functional refinements by George Zengin                        06/27/96
Continued refinements by Phil Barnett                          06/28/96
BIN2HEX routine by Terry Carmen                                06/28/96
F8 - Decimal/Hex toggle by Jo French                           04/16/97
*/

/*
If you own Clipper Tools III, you can speed up the screen refresh by
clipper hexview /m /n /w /dTOOLSIII
at compile time, or feel free to supply any other dec2hex function
*/

/*
If you make improvements to this code, please repost to the
internet newsgroup comp.lang.clipper
*/

#include "common.ch"
#include "fileio.ch"
#include "inkey.ch"

#define BUFFLEN2 4096

static nHandle
static aDisp
static nBuffLen1
static nMaxRow
static lFull     := .f.
static nRowLen
static SCR       := {}
static CNT       := 0
static lDec      := .f.

*+
*+
*+    Procedure HexView()
*+
*+
*+
procedure HexView( cFileToView, cFull )

local nkey
local x
local nFilePtr
local nFileSize
local nFileLast
local xSrch
local Getlist   := {}
local adir
local aDir2
local nOpt      := 1
local origMask
local string

nMaxRow := maxrow()

default cFull to ''
default cFileToView to space( 50 )

if upper( cFull ) == '/F'
   lfull := .t.
endif

nRowLen := iif( lFull, 64, 16 )

setmode( nMaxRow + 1, 80 )

if empty( cFileToView )
   Usage()
   quit
endif

putscreen()

cls
origMask := if( at( '*', cFileToView ) # 0 .or. at( '?', cFileToView ) # 0, ;
                cFileToView, '*.*' )
adir := directory( cFileToView )
if empty( adir )
   getscreen()
   if at( '*', cFileToView ) # 0 .or. at( '?', cFileToView ) # 0
      ? 'No files with mask "' + cFileToView + '"'
   else
      ? 'File ' + cFileToView + ' not found'
   endif
   quit
endif
cFileToView := adir[ 1 ] [ 1 ]

set scoreboard off
set cursor off
setblink( .f. )

nBuffLen1 := ( nMaxRow - 3 ) * nRowLen

if !NewFile( cFileToView, @nFilePtr, @nHandle, @nFileSize, @nFileLast )
   getscreen()
   ? cFileToView + "  File Open Error!!"
   ?
   quit
endif

aDisp := array( nMaxRow - 3, 2 )
fillarray( nFilePtr )

setcolor( 'N/W' )

@  0,  0 clear to 1, 79
@ nMaxRow - 1, 0 clear to nMaxRow, 79

@  0,  1 say 'File: ' + ;         
        upper( if( len( cFileToView ) < nRowLen, cFileToView, ;
        ".." + right( cFileToView, 13 ) ) ) color 'N/W'
@  0, 23 say transform( nFileSize / 1000, "999,999" ) + 'kb'    color 'N/W'        
@  0, 35 say transform( nFileSize, "9,999,999,999" ) + ' bytes' color 'N/W'        
@  0, 55 say dtoc( adir[ nOpt, 3 ] ) + ' ' + adir[ nOpt ] [ 4 ] color 'N/W'        

cnt( 'F2 to Jump  F3 to Search  F8 Toggle DecHex' + ;
     '  F9 Toggle View  F10 New File', nMaxRow - 1 )

cnt( chr( 24 ) + ' ' + chr( 25 ) + ' ' + chr( 27 ) + ' ' + chr( 26 ) + ;
     '    <Page Up>    <Page Down>    <Ctrl-Home>  ' + ;
     '  <Ctrl-End>    <Esc>', nMaxRow )

header( lFull )

setcolor( 'w+/b*' )

for x := 2 to nMaxRow - 2
   @ x,  0 say chr( 219 ) color 'W/N'        
   @ x, 79 say chr( 219 ) color 'W/N'        
next

@  2,  1 clear to nMaxRow - 2, 78

hex_disp( nFilePtr, nFileSize )

do while .t.

   nKey := inkey( 0 )

   do case
   case nKey == K_ESC
      exit

   case nKey == K_PGUP
      nFilePtr := max( 0, nFilePtr - nBuffLen1 )

   case nKey == K_PGDN
      nFilePtr := min( nFileLast, nFilePtr + nBuffLen1 )

   case nKey == K_UP
      nFilePtr := max( 0, nFilePtr - nRowLen )

   case nKey == K_DOWN
      nFilePtr := min( nFileLast, nFilePtr + nRowLen )

   case nKey == K_LEFT
      nFilePtr := max( 0, nFilePtr - 1 )

   case nKey == K_RIGHT
      nFilePtr := min( nFileLast, nFilePtr + 1 )

   case nKey == K_CTRL_HOME .or. nKey == K_CTRL_PGUP
      nFilePtr := 0

   case nKey == K_CTRL_END .or. nKey == K_CTRL_PGDN
      nFilePtr := nFileLast

   case nKey == K_F2
      putscreen( 0, 0, 0, maxcol() )
      xSrch := 0
      @  0, 36 say "Jump to:" get xSrch picture "999999999" ;       
              color "B/W, W/B"
      set cursor on
      read
      set cursor off
      nFilePtr := max( 0, min( nFileLast, xSrch ) )
      getscreen()

   case nKey == K_F3
      putscreen( 0, 0, 0, maxcol() )
      xSrch := space( 10 )
      @  0, 36 say "Search for:" get xSrch picture "@!" color "B/W,W/B"      
      set cursor on
      read
      set cursor off
      if !empty( xSrch )
         nFilePtr := ;
            MySearch( nFilePtr, nFileSize, nFileLast, trim( xSrch ) )
      endif
      getscreen()

   case nKey == K_F8
      lDec := !lDec

   case nKey == K_F9
      lFull     := !lFull
      nRowLen   := iif( lFull, 64, 16 )
      nBuffLen1 := ( nMaxRow - 3 ) * nRowLen
      nFileLast := nFileSize - ( nFileSize % nRowLen )
      nFileLast -= min( int( nFileSize / nRowLen ), nMaxRow - 4 ) * nRowLen
      header( lFull )
      @  2,  1 clear to nMaxRow - 2, 78

   case nKey == K_F10
      setcolor( 'W/B' )
      hex_disp( nFilePtr, nFileSize )
      setcolor( 'W+/B*' )
      @  5, 18, 20, 62 box replicate( chr( 219 ), 8 ) + ' ' color 'W+/B*'         
      adir   := directory( origMask )
      string := ' ' + origMask + ' '
      @  5, 40 - len( string ) / 2 say string color 'W+/B'        
      aDir2 := {}
      aeval( adir, { | x | aadd( aDir2, padr( upper( x[ 1 ] ), 12 ) + ' ' + ;
                     padl( str( x[ 2 ] ), 10 ) + ' ' + ;
                     dtoc( x[ 3 ] ) + ' ' + x[ 4 ] ) } )
      x    := nOpt
      nOpt := achoice( 6, 20, 19, 60, aDir2,,, nOpt )
      if !empty( nOpt )
         fclose( nHandle )
         cFileToView := adir[ nOpt ] [ 1 ]
         if !NewFile( cFileToView, @nFilePtr, @nHandle, ;
                      @ nFileSize, @nFileLast )
            getscreen()
            ? cFileToView + "  File Open Error!!"
            ?
            quit
         endif
         @  0,  1 say 'File: ' + ;         
                 padr( upper( if( len( cFileToView ) < 16, ;
                 cFileToView, ".." + ;
                 right( cFileToView, 13 ) ) ), 15 ) color 'N/W'
         @  0, 23 say transform( nFileSize / 1024, "999,999" ) + ;         
                 ' Kb' color 'N/W'
         @  0, 35 say transform( nFileSize, "9,999,999,999" ) + ;         
                 ' bytes' color 'N/W'
         @  0, 55 say dtoc( adir[ nOpt, 3 ] ) + ' ' + ;         
                 adir[ nOpt ] [ 4 ] color 'N/W'
      else
         nOpt := x
      endif

   otherwise
      loop

   endcase

   fillarray( nFilePtr )
   hex_disp( nFilePtr, nFileSize )

enddo

fclose( nHandle )

getscreen()
usage( .t. )

return

*+
*+
*+    Static Procedure FillArray()
*+
*+    Called from ( hexview.prg  )   2 - procedure hexview()
*+                                   1 - static function mysearch()
*+
*+
*+
static procedure FillArray( nFilePtr )

static cBuffer := ''

local x
local cHex
local n
local cVisable
local bytesread
local nNumRows  := nMaxRow - 4

if len( cBuffer ) <> nBuffLen1
   cBuffer := space( nBuffLen1 )
endif

fseek( nHandle, nFilePtr, FS_SET )

bytesread := fread( nHandle, @cBuffer, nBuffLen1 )

if bytesread <> nBuffLen1
   cBuffer := left( cBuffer, bytesread )
endif

for x := 0 to nNumRows
   n := x + 1

   cVisable := substr( cBuffer, ( x * nRowLen ) + 1, nRowLen )
   aDisp[ n ] [ 2 ] := len( cVisable )
   cHex := ''

   if !lFull        && if not in full screen mode
      cHex := bin2hex( pad( left( cVisable, 8 ), 8 ) ) + '  ' + ;
                       bin2hex( pad( substr( cVisable, 9, 8 ), 8 ) ) + ' '
   endif

   if !lDec
#ifdef TOOLSIII
      aDisp[ n ] [ 1 ] := ntoc( nFilePtr + ;
              ( x * nRowLen ), 16, 8, '0' ) + ;
              ': ' + iif( !lFull, cHex + '  ', '' ) + ;
              pad( cVisable, nRowLen ) + ' '
#else
      aDisp[ n ] [ 1 ] := padl( dec2hex( nFilePtr + ;
              ( x * nRowLen ) ), 8, '0' ) + ;
              ': ' + iif( !lFull, cHex + '  ', '' ) + ;
              pad( cVisable, nRowLen ) + ' '
#endif
   else
      aDisp[ n ] [ 1 ] := padl( alltrim( str( nFilePtr + ;
              ( x * nRowLen ), 8, 0 ) ), 8, '0' ) + ;
              ': ' + iif( !lFull, cHex + '  ', '' ) + ;
              pad( cVisable, nRowLen ) + ' '
   endif
next

return

*+
*+
*+    Static Procedure Hex_Disp()
*+
*+    Called from ( hexview.prg  )   3 - procedure hexview()
*+                                   1 - static function mysearch()
*+
*+
*+
static procedure Hex_Disp( nFilePtr, nFileSize )

local x
local n
local lShowedEof := .f.
local nEol
local nLastRow   := nMaxRow - 3

dispbegin()

for x := 1 to nLastRow
   n := x + 1

   do case
   case aDisp[ x ] [ 2 ] == nRowLen
      @ n,  1 say aDisp[ x ] [ 1 ]         

   case aDisp[ x ] [ 2 ] == 0
      if lShowedEof
         @ n,  1 clear to n, 78
      else
         @ n,  1 say aDisp[ x ] [ 1 ]                       
         @ n, 11 say '<EOF>'          color 'GB+/B*'        
         @ n, 16 clear to n, 78
         lShowedEof := .t.
      endif
   case lFull .and. aDisp[ x ] [ 2 ] < nRowLen
      @ n,  1 say aDisp[ x ] [ 1 ]         
      if !lShowedEof
         nEol := 11 + aDisp[ x ] [ 2 ]
         @ n, nEol say '<EOF>' color 'GB+/B*'        
         @ n, nEol + 5 clear to n, 60
         lShowedEof := .t.
      endif
   case aDisp[ x ] [ 2 ] < 8
      @ n,  1 say aDisp[ x ] [ 1 ]         
      if !lShowedEof
         nEol := 11 + ( aDisp[ x ] [ 2 ] * 3 )
         @ n, nEol say '<EOF>' color 'GB+/B*'        
         @ n, nEol + 5 clear to n, 60
         lShowedEof := .t.
      endif
   case aDisp[ x ] [ 2 ] < 16
      @ n,  1 say aDisp[ x ] [ 1 ]         
      if !lShowedEof
         nEol := 12 + ( aDisp[ x ] [ 2 ] * 3 )
         @ n, nEol say '<EOF>' color 'GB+/B*'        
         @ n, nEol + 5 clear to n, 60
         lShowedEof := .t.
      endif
   endcase

   @ n, 79 say chr( 219 ) color 'W/N'        

next

@ ( ( nFilePtr / nFileSize ) * nLastRow ) + 2, 79 say chr( 254 ) color 'GB+/W'        

dispend()

return

*+
*+
*+    Static Function Dec2Hex()
*+
*+    Called from ( hexview.prg  )   1 - static procedure fillarray()
*+                                   1 - static function mysearch()
*+
*+
*+
static function Dec2Hex( nDecIn )
static aHex     := { '0', '1', '2', '3', '4', '5', '6', '7', ;
                     '8', '9', 'A', 'B', 'C', 'D', 'E', 'F' }

local cHexOut := ''

do while nDecIn > 0
   cHexOut := aHex[ ( nDecIn % 16 ) + 1 ] + cHexOut
   nDecIn  := int( nDecIn / 16 )
enddo

return cHexOut

*+
*+
*+    Static Procedure Cnt()
*+
*+    Called from ( hexview.prg  )   2 - procedure hexview()
*+
*+
*+
static procedure Cnt( cString, nRow )

cString := alltrim( cString )

@ nRow, ( 79 - len( cString ) ) / 2 say cString         

return

*+
*+
*+    Static Function MySearch()
*+
*+    Called from ( hexview.prg  )   1 - procedure hexview()
*+
*+
*+
static function MySearch( nPtr, nFileSize, nFileLast, cSrch )

local nLen     := len( cSrch )
local cBuffer
local nTmp
local nRead
local nFound
local nFilePtr := 0
local nKey     := K_F3

nPtr := fseek( nHandle, nPtr, 0 )

while .t.
   nTmp    := nPtr
   cBuffer := space( BUFFLEN2 )
   nRead   := fread( nHandle, @cBuffer, BUFFLEN2 )
   while ( nFound := at( cSrch, upper( cBuffer ) ) ) > 0
      nTmp += nFound - 1
      if !lDec
         @  0, 60 say "Found at :" + padl( Dec2Hex( nTmp ), 8, "0" ) ;         
                 color "B/W"
      else
         @  0, 60 say "Found at :" + ;         
                 padl( alltrim( str( nTmp, 8, 0 ) ), 8, "0" ) color "B/W"
      endif
      nFilePtr := min( nFileLast, int( nTmp / nRowLen ) * nRowLen )
      fillarray( nFilePtr )
      hex_disp( nFilePtr, nFileSize )
      if ( nKey := inkey( 0 ) ) != K_F3
         exit
      endif
      cBuffer := substr( cBuffer, nFound + nLen )
      nTmp    += nLen
   end
   if nRead < BUFFLEN2 .or. nKey != K_F3
      exit
   endif
   fseek( nHandle, - nLen + 1, 1 )
   nPtr := fseek( nHandle, 0, 1 )
end

return nFilePtr

*+
*+
*+    Static Procedure PutScreen()
*+
*+    Called from ( hexview.prg  )   3 - procedure hexview()
*+
*+
*+
static procedure PutScreen( t, l, b, r )

Default T to 0
Default L to 0
Default b to maxrow()
Default r to maxcol()

aadd( SCR, { T, L, b, r, savescreen( T, L, b, r ), row(), col(), ;
             set( _SET_CURSOR ), setcolor() } )
CNT ++

return

*+
*+
*+    Static Procedure GetScreen()
*+
*+    Called from ( hexview.prg  )   6 - procedure hexview()
*+
*+
*+
static procedure GetScreen( option )

Default OPTION to 1

do case
case OPTION == 0
   CNT := 0
   SCR := {}
case OPTION == - 1
   asize( SCR, -- CNT )
otherwise
   if CNT > 0
      restscreen( SCR[ cnt, 1 ], SCR[ cnt, 2 ], SCR[ cnt, 3 ], ;
                  SCR[ cnt, 4 ], SCR[ cnt, 5 ] )
      devpos( SCR[ cnt, 6 ], SCR[ cnt, 7 ] )
      set( _SET_CURSOR, SCR[ cnt, 8 ] )
      setcolor( SCR[ cnt, 9 ] )
      asize( SCR, -- CNT )
   endif
endcase

return

*+
*+
*+    Static Procedure Usage()
*+
*+    Called from ( hexview.prg  )   2 - procedure hexview()
*+
*+
*+
static procedure Usage( short )

default short to .f.

if short
   ? 'HEXVIEW -=- Public Domain from comp.lang.clipper'
   ?
else
   ? 'HEXVIEW -=- File Viewer'
   ?
   ? 'Released to Public Domain by author, Phil Barnett'
   ?
   ? 'Contributing Authors:  Jo French'
   ? '                       George Zengin'
   ? '                       Terry Carmen'
   ? ''
   ? 'Usage: HEXVIEW <filename> [/F]'
   ? '       where   <filename> is the name of the file you want to browse'
   ?
   ? '       HEXVIEW <filespec> [/F]'
   ? '       where   <filespec> contains dos wildcards ? and *'
   ?
   ? '       and     [/F] is an optional parameter for a full screen browse.'
   ?
endif

return

*+
*+
*+    Static Function NewFile()
*+
*+    Called from ( hexview.prg  )   2 - procedure hexview()
*+
*+
*+
static function NewFile( cFileToView, nFilePtr, nHandle, nFileSize, nFileLast )

nFilePtr := 0

if ( nHandle := fopen( cFileToView, 64 ) ) < 0
   return .f.
endif

nFileSize := fseek( nHandle, 0, FS_END )
nFileLast := nFileSize - ( nFileSize % nRowLen )
nFileLast -= min( int( nFileSize / nRowLen ), nMaxRow - 4 ) * nRowLen

return .t.

*+
*+
*+    Static Procedure header()
*+
*+
*+
static procedure header( lFull )

if lFull
   @  1, 11 say "0123456789ABCDEF0123456789ABCDEF" + ;         
           "0123456789ABCDEF0123456789ABCDEF   " color 'N/W'
else
   @  1, 11 say "00 01 02 03 04 05 06 07 " + ;         
           " 08 09 0A 0B 0C 0D 0E 0F   0123456789ABCDEF" color 'N/W'
endif

return

*+ EOF: HEXVIEW.PRG
